save_params <- function(path_param){
	res = ""	# 	Page : global_params
		res = paste0(res , paste("global_params:", paste0('"', input$selectglobal_params, '"'), "\n", sep = " "))
		if(!is.na(as.numeric(input$results_dir))) {
			res = paste0(res, paste("results_dir:", input$results_dir, "\n", sep = " "))
		} else {
			res = paste0(res, paste("results_dir:", paste0('"', input$results_dir, '"'), "\n", sep = " "))
		}	

		if(!is.na(as.numeric(input$sample_dir))) {
			res = paste0(res, paste("sample_dir:", input$sample_dir, "\n", sep = " "))
		} else {
			res = paste0(res, paste("sample_dir:", paste0('"', input$sample_dir, '"'), "\n", sep = " "))
		}	

		res = paste0(res, paste("group_file_select:", paste0('"', input$group_file_select, '"'), "\n", sep = " "))
		if(input$group_file_select == "server") {
			res = paste0(res, paste("group_file:", paste0('"', input$group_file_server, '"'), "\n", sep = " "))
		}
		if(input$group_file_select == "local"){
			res = paste0(res, paste("group_file:", paste0('"', input$group_file_local$datapath, '"'), "\n", sep = " "))
		}	

		if(!is.na(as.numeric(input$SeOrPe))) {
			res = paste0(res, paste("SeOrPe:", input$SeOrPe, "\n", sep = " "))
		} else {
			res = paste0(res, paste("SeOrPe:", paste0('"', input$SeOrPe, '"'), "\n", sep = " "))
		}	

		if(!is.na(as.numeric(input$memo))) {
			res = paste0(res, paste("memo:", input$memo, "\n", sep = " "))
		} else {
			res = paste0(res, paste("memo:", paste0('"', input$memo, '"'), "\n", sep = " "))
		}	

	# 	Page : trimming
		res = paste0(res , paste("trimming:", paste0('"', input$selecttrimming, '"'), "\n", sep = " "))
		if(!is.na(as.numeric(input$trimmomatic_threads))) {
			res = paste0(res, paste("trimmomatic_threads:", input$trimmomatic_threads, "\n", sep = " "))
		} else {
			res = paste0(res, paste("trimmomatic_threads:", paste0('"', input$trimmomatic_threads, '"'), "\n", sep = " "))
		}	

		if(!is.na(as.numeric(input$trimmomatic_qc_score))) {
			res = paste0(res, paste("trimmomatic_qc_score:", input$trimmomatic_qc_score, "\n", sep = " "))
		} else {
			res = paste0(res, paste("trimmomatic_qc_score:", paste0('"', input$trimmomatic_qc_score, '"'), "\n", sep = " "))
		}	

	# 	Page : quality_check
		res = paste0(res , paste("quality_check:", paste0('"', input$selectquality_check, '"'), "\n", sep = " "))
		if(!is.na(as.numeric(input$fastqc_threads))) {
			res = paste0(res, paste("fastqc_threads:", input$fastqc_threads, "\n", sep = " "))
		} else {
			res = paste0(res, paste("fastqc_threads:", paste0('"', input$fastqc_threads, '"'), "\n", sep = " "))
		}	

	# 	Page : quantification
		res = paste0(res , paste("quantification:", paste0('"', input$selectquantification, '"'), "\n", sep = " "))
		res = paste0(res, paste("kallisto_index_input_select:", paste0('"', input$kallisto_index_input_select, '"'), "\n", sep = " "))
		if(input$kallisto_index_input_select == "server") {
			res = paste0(res, paste("kallisto_index_input:", paste0('"', input$kallisto_index_input_server, '"'), "\n", sep = " "))
		}
		if(input$kallisto_index_input_select == "local"){
			res = paste0(res, paste("kallisto_index_input:", paste0('"', input$kallisto_index_input_local$datapath, '"'), "\n", sep = " "))
		}	

		if(!is.na(as.numeric(input$kallisto_quant_threads))) {
			res = paste0(res, paste("kallisto_quant_threads:", input$kallisto_quant_threads, "\n", sep = " "))
		} else {
			res = paste0(res, paste("kallisto_quant_threads:", paste0('"', input$kallisto_quant_threads, '"'), "\n", sep = " "))
		}	

		if(!is.na(as.numeric(input$kallisto_quant_fragment_length_SE))) {
			res = paste0(res, paste("kallisto_quant_fragment_length_SE:", input$kallisto_quant_fragment_length_SE, "\n", sep = " "))
		} else {
			res = paste0(res, paste("kallisto_quant_fragment_length_SE:", paste0('"', input$kallisto_quant_fragment_length_SE, '"'), "\n", sep = " "))
		}	

		if(!is.na(as.numeric(input$kallisto_quant_standard_deviation_SE))) {
			res = paste0(res, paste("kallisto_quant_standard_deviation_SE:", input$kallisto_quant_standard_deviation_SE, "\n", sep = " "))
		} else {
			res = paste0(res, paste("kallisto_quant_standard_deviation_SE:", paste0('"', input$kallisto_quant_standard_deviation_SE, '"'), "\n", sep = " "))
		}	

		if(!is.na(as.numeric(input$kallisto_quant_stranded_PE))) {
			res = paste0(res, paste("kallisto_quant_stranded_PE:", input$kallisto_quant_stranded_PE, "\n", sep = " "))
		} else {
			res = paste0(res, paste("kallisto_quant_stranded_PE:", paste0('"', input$kallisto_quant_stranded_PE, '"'), "\n", sep = " "))
		}	

		res = paste0(res, paste("salmon_index_input_select:", paste0('"', input$salmon_index_input_select, '"'), "\n", sep = " "))
		if(input$salmon_index_input_select == "server") {
			res = paste0(res, paste("salmon_index_input:", paste0('"', input$salmon_index_input_server, '"'), "\n", sep = " "))
		}
		if(input$salmon_index_input_select == "local"){
			res = paste0(res, paste("salmon_index_input:", paste0('"', input$salmon_index_input_local$datapath, '"'), "\n", sep = " "))
		}	

		if(!is.na(as.numeric(input$salmon_index_threads))) {
			res = paste0(res, paste("salmon_index_threads:", input$salmon_index_threads, "\n", sep = " "))
		} else {
			res = paste0(res, paste("salmon_index_threads:", paste0('"', input$salmon_index_threads, '"'), "\n", sep = " "))
		}	

		if(!is.na(as.numeric(input$salmon_quant_threads))) {
			res = paste0(res, paste("salmon_quant_threads:", input$salmon_quant_threads, "\n", sep = " "))
		} else {
			res = paste0(res, paste("salmon_quant_threads:", paste0('"', input$salmon_quant_threads, '"'), "\n", sep = " "))
		}	

	# 	Page : DE
		res = paste0(res , paste("DE:", paste0('"', input$selectDE, '"'), "\n", sep = " "))
		if(!is.na(as.numeric(input$edger_threads))) {
			res = paste0(res, paste("edger_threads:", input$edger_threads, "\n", sep = " "))
		} else {
			res = paste0(res, paste("edger_threads:", paste0('"', input$edger_threads, '"'), "\n", sep = " "))
		}	

		if(input$edger_tx2gene) {
			res = paste0(res, paste("edger_tx2gene:", "true", "\n", sep = " "))
		} else {
			res = paste0(res, paste("edger_tx2gene:", "false", "\n", sep = " "))
		}	

		res = paste0(res, paste("edger_annotations_select:", paste0('"', input$edger_annotations_select, '"'), "\n", sep = " "))
		if(input$edger_annotations_select == "server") {
			res = paste0(res, paste("edger_annotations:", paste0('"', input$edger_annotations_server, '"'), "\n", sep = " "))
		}
		if(input$edger_annotations_select == "local"){
			res = paste0(res, paste("edger_annotations:", paste0('"', input$edger_annotations_local$datapath, '"'), "\n", sep = " "))
		}	

		if(!is.na(as.numeric(input$edger_normfact))) {
			res = paste0(res, paste("edger_normfact:", input$edger_normfact, "\n", sep = " "))
		} else {
			res = paste0(res, paste("edger_normfact:", paste0('"', input$edger_normfact, '"'), "\n", sep = " "))
		}	

		if(!is.na(as.numeric(input$edger_dispersion))) {
			res = paste0(res, paste("edger_dispersion:", input$edger_dispersion, "\n", sep = " "))
		} else {
			res = paste0(res, paste("edger_dispersion:", paste0('"', input$edger_dispersion, '"'), "\n", sep = " "))
		}	

		if(!is.na(as.numeric(input$edger_testType))) {
			res = paste0(res, paste("edger_testType:", input$edger_testType, "\n", sep = " "))
		} else {
			res = paste0(res, paste("edger_testType:", paste0('"', input$edger_testType, '"'), "\n", sep = " "))
		}	

		if(!is.na(as.numeric(input$deseq2_threads))) {
			res = paste0(res, paste("deseq2_threads:", input$deseq2_threads, "\n", sep = " "))
		} else {
			res = paste0(res, paste("deseq2_threads:", paste0('"', input$deseq2_threads, '"'), "\n", sep = " "))
		}	

		if(input$deseq2_tx2gene) {
			res = paste0(res, paste("deseq2_tx2gene:", "true", "\n", sep = " "))
		} else {
			res = paste0(res, paste("deseq2_tx2gene:", "false", "\n", sep = " "))
		}	

		res = paste0(res, paste("deseq2_annotations_select:", paste0('"', input$deseq2_annotations_select, '"'), "\n", sep = " "))
		if(input$deseq2_annotations_select == "server") {
			res = paste0(res, paste("deseq2_annotations:", paste0('"', input$deseq2_annotations_server, '"'), "\n", sep = " "))
		}
		if(input$deseq2_annotations_select == "local"){
			res = paste0(res, paste("deseq2_annotations:", paste0('"', input$deseq2_annotations_local$datapath, '"'), "\n", sep = " "))
		}	

	a = yaml.load_file("/workflow/params.total.yml")
	p = a[["params"]]
	a["params"] = NULL
	b = yaml.load(res)
	pnotb = subset(names(p), !(names(p)%in%names(b)))
	d = list()
	d$params = c(p[pnotb],b)
	logical = function(x) {
		result <- ifelse(x, "True", "False")
		class(result) <- "verbatim"
		return(result)
	}
	d = c(d,a)
	get_samples = yaml.load(system(paste0("python3 /workflow/get_samples.py ",input$sample_dir," ",input$SeOrPe),intern = T))
	d$samples = get_samples$samples
	d$params$sample_suffix = get_samples$suffix
	write_yaml(d,path_param,handlers=list(logical = logical))
	}

force_rule <- function(force_from){
	if (input$force_from=="none"){
		return("")
	}
	else if (input$force_from=="all"){ return("--forcerun all") }
	else {
		params = yaml.load_file(paste0(input$results_dir,"/params.yml"))
		outputs = params[["outputs"]]
		tool = params[["params"]][[force_from]]
		if (length(outputs[[tool]])==1)
			rule = names(outputs[[tool]])[[1]]
		else{
			rule = names(outputs[[tool]])[[grep(input$SeOrPe,names(outputs[[tool]]))]]
		}
		return(paste0("--forcerun ",rule))
	}
}
#' Event when use RULEGRAPH button
observeEvent({c(input$sidebarmenu,input$refresh_rg)}, {

	if(input$sidebarmenu=="RULEGRAPH"){
		input_list <- reactiveValuesToList(input)
		toggle_inputs(input_list,F,F)
		path_param <- paste0(input$results_dir,"/params.yml")

		save_params(path_param)
		i = sample.int(1000,size = 1)

		system(paste0("rm ",input$results_dir,"/rulegraph*"))

		outUI = tryCatch({
			system(paste0("snakemake -s /workflow/Snakefile --configfile ",input$results_dir,"/params.yml -d ",input$results_dir," all --rulegraph > ",input$results_dir,"/rulegraph",i,".dot"),intern=T)
			system(paste0("cat ",input$results_dir,"/rulegraph",i,".dot | dot -Tsvg -Gratio=0.75 > ",input$results_dir,"/rulegraph",i,".svg"),intern=T)
			tagList(img(src = paste0("results/rulegraph",i,".svg") ,alt = "Rulegraph of Snakemake jobs",style="max-width: 100%;height: auto;display: block;margin: auto"))},
		error = function(e){
			system(paste0("touch ",input$results_dir,"/logs/workflow_end.error"),wait = T)
			return(tags$p(paste0("error : ",e$message)))},
		warning = function(w){
			system(paste0("touch ",input$results_dir,"/logs/workflow_end.error"),wait = T)
			return(tags$p(paste0("error : ",w$message)))})
		addResourcePath("results", input$results_dir)
		output$RULEGRAPH_svg = renderUI(outUI)
		toggle_inputs(input_list,T,F)
}})
#' Event when use RunPipeline button
observeEvent(input$RunPipeline, {

	rv$running = T
	input_list <- reactiveValuesToList(input)
	toggle_inputs(input_list,F,F)
	updateTabsetPanel(session, "sidebarmenu", selected = "run_out")
	path_param <- paste0(input$results_dir,"/params.yml")

		save_params(path_param)


	outUI = tryCatch({
		if (!dir.exists(paste0(input$results_dir,"/logs"))){
			dir.create(paste0(input$results_dir,"/logs"))
		}
		if (!file.exists(paste0(input$results_dir,"/logs/runlog.txt"))){
			file.create(paste0(input$results_dir,"/logs/runlog.txt"))
		}
		system(paste0("touch ",input$results_dir,"/logs/workflow.running"),wait = T)
			system(paste0("snakemake -s /workflow/Snakefile --configfile ",input$results_dir,"/params.yml -d ",input$results_dir," all --rulegraph | dot -Tpng -Gratio=0.75 > ",input$results_dir,"/Rule_graph_mqc.png"))
		force = force_rule(input$force_from)
		rerun = if (input$rerun_incomplete) "--rerun-incomplete" else ""
		system2("python3",paste0("-u -m snakemake -s /workflow/Snakefile --configfile ", paste0(input$results_dir,"/params.yml") ,	" -d ", input$results_dir ,	" --cores ", input$cores, " all ", force, " ",rerun),wait = FALSE, stdout = paste0(input$results_dir,"/logs/runlog.txt"), stderr = paste0(input$results_dir,"/logs/runlog.txt"))
		tags$iframe(src="results/multiqc_report.html",width="100%", height="900px")},
		error = function(e){
			system(paste0("touch ",input$results_dir,"/logs/workflow_end.error"),wait = T)
			return(tags$p(paste0("error : ",e$message)))},
		warning = function(w){
			system(paste0("touch ",input$results_dir,"/logs/workflow_end.error"),wait = T)
			return(tags$p(paste0("error : ",w$message)))})
		})

		shinyDirChoose(input, "shinydir_results_dir", root=c(Results="/Results"),session = session)
		observeEvent({parseDirPath(c(Results="/Results"),input$shinydir_results_dir)},{
			updateTextInput(session,"results_dir",value = parseDirPath(c(Results="/Results"),input$shinydir_results_dir))
		})

		shinyDirChoose(input, "shinydir_sample_dir", root=c(Data="/Data",Results="/Results"),session = session)
		observeEvent({parseDirPath(c(Data="/Data",Results="/Results"),input$shinydir_sample_dir)},{
			updateTextInput(session,"sample_dir",value = parseDirPath(c(Data="/Data",Results="/Results"),input$shinydir_sample_dir))
		})

		shinyFileChoose(input, "shinyfiles_group_file", root=c(Data="/Data",Results="/Results"),session = session)
		observeEvent({parseFilePaths(c(Data="/Data",Results="/Results"),input$shinyfiles_group_file)$datapath[1]},{
			updateTextInput(session,"group_file_server",value = parseFilePaths(c(Data="/Data",Results="/Results"),input$shinyfiles_group_file)$datapath[1])
		})

		shinyFileChoose(input, "shinyfiles_kallisto_index_input", root=c(Data="/Data",Results="/Results"),session = session)
		observeEvent({parseFilePaths(c(Data="/Data",Results="/Results"),input$shinyfiles_kallisto_index_input)$datapath[1]},{
			updateTextInput(session,"kallisto_index_input_server",value = parseFilePaths(c(Data="/Data",Results="/Results"),input$shinyfiles_kallisto_index_input)$datapath[1])
		})

		shinyFileChoose(input, "shinyfiles_salmon_index_input", root=c(Data="/Data",Results="/Results"),session = session)
		observeEvent({parseFilePaths(c(Data="/Data",Results="/Results"),input$shinyfiles_salmon_index_input)$datapath[1]},{
			updateTextInput(session,"salmon_index_input_server",value = parseFilePaths(c(Data="/Data",Results="/Results"),input$shinyfiles_salmon_index_input)$datapath[1])
		})

		shinyFileChoose(input, "shinyfiles_edger_annotations", root=c(Data="/Data",Results="/Results"),session = session)
		observeEvent({parseFilePaths(c(Data="/Data",Results="/Results"),input$shinyfiles_edger_annotations)$datapath[1]},{
			updateTextInput(session,"edger_annotations_server",value = parseFilePaths(c(Data="/Data",Results="/Results"),input$shinyfiles_edger_annotations)$datapath[1])
		})

		shinyFileChoose(input, "shinyfiles_deseq2_annotations", root=c(Data="/Data",Results="/Results"),session = session)
		observeEvent({parseFilePaths(c(Data="/Data",Results="/Results"),input$shinyfiles_deseq2_annotations)$datapath[1]},{
			updateTextInput(session,"deseq2_annotations_server",value = parseFilePaths(c(Data="/Data",Results="/Results"),input$shinyfiles_deseq2_annotations)$datapath[1])
		})


